#include<bits/stdc++.h>
using namespace std;
#define siz(x) (int)(x).size()
#define int long long
typedef pair<int,int> Pii;
const int N=1005,Mod=998244353;
int n,m,c,f;
char a[N][N];
int sufh[N][N],sufl[N][N],sufC[N][N],sufF[N][N];
inline int Sub(int x,int y){x-=y;if(x<0)x+=Mod;return x;}
inline void Add(int &x,int y){x+=y;if(x>=Mod)x-=Mod;}
inline int Add1(int x,int y){x+=y;if(x>=Mod)x-=Mod;return x;}
inline void solve()
{
    cin>>n>>m>>c>>f;
    for(int i=1;i<=n;i++)cin>>(a[i]+1);
    if(c==0&&f==0)return cout<<0<<' '<<0<<'\n',void ();
    for(int i=1;i<=n;i++)
        for(int j=m;j;j--)
            sufh[i][j]=(a[i][j]=='0'?sufh[i][j+1]+1:0);
    
    for(int j=1;j<=m;j++)
        for(int i=n;i;i--)
            sufl[i][j]=(a[i][j]=='0'?sufl[i+1][j]+1:0);
    for(int j=1;j<=m;j++)
        for(int i=n;i;i--)
            sufC[i][j]=(a[i][j]=='0'?Add1(sufC[i+1][j],(sufh[i][j]-1)):0);
    for(int j=1;j<=m;j++)
        for(int i=n;i;i--)
            sufF[i][j]=(a[i][j]=='0'?Add1(sufF[i+1][j],(sufh[i][j]-1)*(sufl[i][j]-1)%Mod):0);
    int ansc=0,ansf=0;
    // for(int i=1;i<=n;i++)
    //     for(int j=1;j<=m;j++)
    //         if(a[i][j]=='0'&&sufh[i][j]>1&&sufl[i][j]>2)
    //         {
    //             for(int k=2;k<sufl[i][j];k++)
    //                 if(sufh[i+k][j]>1)
    //                     Add(ansc,Sub(sufh[i][j],1)*Sub(sufh[i+k][j],1)%Mod),
    //                     Add(ansf,Sub(sufh[i][j],1)*Sub(sufh[i+k][j],1)%Mod*Sub(sufl[i+k][j],1)%Mod);
    //         }
    for(int i=1;i<=n;i++)
        for(int j=1;j<=m;j++)
            if(a[i][j]=='0'&&sufh[i][j]>1&&sufl[i][j]>2)
            {
                Add(ansc,(sufh[i][j]-1)*sufC[i+2][j]%Mod);
                Add(ansf,(sufh[i][j]-1)*sufF[i+2][j]%Mod);
            }
    cout<<ansc*c<<' '<<ansf*f<<'\n';
    
}

inline void clear()
{
    for(int i=1;i<=n;i++)
        memset(sufh[i]+1,0,sizeof(int)*m),
        memset(sufl[i]+1,0,sizeof(int)*m),
        memset(sufC[i]+1,0,sizeof(int)*m),
        memset(sufF[i]+1,0,sizeof(int)*m);
}
signed main()
{
    freopen("plant.in","r",stdin);
    freopen("plant.out","w",stdout);
    ios::sync_with_stdio(0);
    cin.tie(0),cout.tie(0);
    int T,id;cin>>T>>id;
    while(T--)solve(),clear();
    // cerr<<clock()<<'\n';
    return 0;
}

/*
636915723 40522441
636915723 40522441
636915723 40522441
636915723 40522441
636915723 40522441
*/